? Installation.el
? package-get-custom.el
Index: package-admin.el
===================================================================
RCS file: /users/darrylo/sources/.repository/xemacs-21.0/lisp/package-admin.el,v
retrieving revision 1.1.1.1
diff -c -r1.1.1.1 package-admin.el
*** package-admin.el	1998/04/26 19:31:56	1.1.1.1
--- package-admin.el	1998/08/02 05:11:56
***************
*** 38,43 ****
--- 38,49 ----
  (defvar package-admin-temp-buffer "*Package Output*"
    "Temporary buffer where output of backend commands is saved.")
  
+ (defvar package-admin-install-function 'package-admin-default-install-function
+   "The function to call to install a package.
+ Three args are passed: FILENAME PKG-DIR BUF
+ Install package FILENAME into directory PKG-DIR, with any messages output
+ to buffer BUF.")
+ 
  ;;;###autoload
  (defun package-admin-add-single-file-package (file destdir &optional pkg-dir)
    "Install a single file Lisp package into XEmacs package hierarchy.
***************
*** 57,62 ****
--- 63,85 ----
  		  ;; rest of command line follows
  		  package-admin-xemacs file destination)))
  
+ (defun package-admin-install-function-mswindows (file pkg-dir buf)
+   "Install function for mswindows"
+   (let ( (default-directory pkg-dir) )
+     (call-process "djtar" nil buf t "-x" file)
+     ))
+ 
+ (defun package-admin-default-install-function (file pkg-dir buf)
+   "Default function to install a package.
+ Install package FILENAME into directory PKG-DIR, with any messages output
+ to buffer BUF."
+   (call-process "add-big-package.sh"
+ 		nil
+ 		buf
+ 		t
+ 		;; rest of command line follows
+ 		package-admin-xemacs file pkg-dir))
+ 
  ;;;###autoload
  (defun package-admin-add-binary-package (file &optional pkg-dir)
    "Install a pre-bytecompiled XEmacs package into package hierarchy."
***************
*** 68,79 ****
      (setq pkg-dir (car (last late-packages))))
  
    (let ((buf (get-buffer-create package-admin-temp-buffer)))
!     (call-process "add-big-package.sh"
! 		  nil
! 		  buf
! 		  t
! 		  ;; rest of command line follows
! 		  package-admin-xemacs file pkg-dir)))
  
  (provide 'package-admin)
  
--- 91,98 ----
      (setq pkg-dir (car (last late-packages))))
  
    (let ((buf (get-buffer-create package-admin-temp-buffer)))
!     (funcall package-admin-install-function
! 	     file pkg-dir buf)))
  
  (provide 'package-admin)
  
Index: package-get.el
===================================================================
RCS file: /users/darrylo/sources/.repository/xemacs-21.0/lisp/package-get.el,v
retrieving revision 1.1.1.7
diff -c -r1.1.1.7 package-get.el
*** package-get.el	1998/07/11 02:04:00	1.1.1.7
--- package-get.el	1998/08/02 05:11:56
***************
*** 155,161 ****
      ("ftp.xemacs.org" "/pub/xemacs/package"))
    "*List of remote sites to contact for downloading packages.
  List format is '(site-name directory-on-site).  Each site is tried in
! order until the package is found.")
  
  (defvar package-get-remove-copy nil
    "*After copying and installing a package, if this is T, then remove the
--- 155,162 ----
      ("ftp.xemacs.org" "/pub/xemacs/package"))
    "*List of remote sites to contact for downloading packages.
  List format is '(site-name directory-on-site).  Each site is tried in
! order until the package is found.  As a special case, `site-name' can be
! `nil', in which case `directory-on-site' is treated as a local directory.")
  
  (defvar package-get-remove-copy nil
    "*After copying and installing a package, if this is T, then remove the
***************
*** 171,176 ****
--- 172,212 ----
  	     (car pkg) nil))
            packages-package-list))
  
+ (defun package-get-interactive-package-query (get-version package-symbol)
+   "Perform interactive querying for package and optional version.
+ Query for a version if GET-VERSION is non-nil.  Return package name as
+ a symbol instead of a string if PACKAGE-SYMBOL is non-nil.
+ The return value is suitable for direct passing to `interactive'."
+   (let ( (table (mapcar '(lambda (item)
+ 			   (let ( (name (format "%s" (car item))) )
+ 			     (cons name name)
+ 			     ))
+ 			package-get-base)) 
+ 	 package package-symbol default-version)
+     (save-window-excursion
+       (setq package (completing-read "Package: " table nil t))
+       (setq package-symbol (intern package))
+       (if get-version
+ 	  (progn
+ 	    (setq default-version 
+ 		  (package-get-info-prop 
+ 		   (package-get-info-version
+ 		    (package-get-info-find-package package-get-base
+ 						   package-symbol) nil)
+ 		   'version))
+ 	    (while (string=
+ 		    (setq version (read-string "Version: " default-version))
+ 		    "")
+ 	      )
+ 	    (if package-symbol
+ 		(list package-symbol version)
+ 	      (list package version))
+ 	    )
+ 	(if package-symbol
+ 	    (list package-symbol)
+ 	  (list package)))
+       )))
+ 
  ;;;###autoload
  (defun package-get-all (package version &optional fetched-packages)
    "Fetch PACKAGE with VERSION and all other required packages.
***************
*** 178,184 ****
  package provides that functionality.  If VERSION is nil, retrieves
  latest version.  Optional argument FETCHED-PACKAGES is used to keep
  track of packages already fetched."
!   (interactive "sPackage: \nsVersion: ")
    (let* ((the-package (package-get-info-find-package package-get-base
  						     package))
  	 (this-package (package-get-info-version
--- 214,220 ----
  package provides that functionality.  If VERSION is nil, retrieves
  latest version.  Optional argument FETCHED-PACKAGES is used to keep
  track of packages already fetched."
!   (interactive (package-get-interactive-package-query t nil))
    (let* ((the-package (package-get-info-find-package package-get-base
  						     package))
  	 (this-package (package-get-info-version
***************
*** 228,241 ****
  Once the package is retrieved, its md5 checksum is computed.  If that
  sum does not match that stored in `package-get-base' for this version
  of the package, an error is signalled."
!   (interactive "xPackage List: ")
    (let* ((this-package
  	  (package-get-info-version
  	   (package-get-info-find-package package-get-base
  					  package) version))
  	 (found nil)
  	 (search-dirs package-get-remote)
! 	 (filename (package-get-info-prop this-package 'filename)))
      (if (null this-package)
  	(error "Couldn't find package %s with version %s"
  	       package version))
--- 264,278 ----
  Once the package is retrieved, its md5 checksum is computed.  If that
  sum does not match that stored in `package-get-base' for this version
  of the package, an error is signalled."
!   (interactive (package-get-interactive-package-query nil t))
    (let* ((this-package
  	  (package-get-info-version
  	   (package-get-info-find-package package-get-base
  					  package) version))
  	 (found nil)
  	 (search-dirs package-get-remote)
! 	 (filename (package-get-info-prop this-package 'filename))
! 	 full-package-filename)
      (if (null this-package)
  	(error "Couldn't find package %s with version %s"
  	       package version))
***************
*** 249,277 ****
        ;; and copy it into the staging directory.  Then validate
        ;; the checksum.  Finally, install the package.
        (while (and search-dirs
! 		  (not (file-exists-p (package-get-staging-dir filename))))
! 	(if (file-exists-p (package-get-remote-filename
! 			    (car search-dirs) filename))
! 	    (copy-file (package-get-remote-filename (car search-dirs) filename)
! 		       (package-get-staging-dir filename))
! 	  (setq search-dirs (cdr search-dirs))
! 	  ))
!       (if (not (file-exists-p (package-get-staging-dir filename)))
  	  (error "Unable to find file %s" filename))
        ;; Validate the md5 checksum
        ;; Doing it with XEmacs removes the need for an external md5 program
        (with-temp-buffer
  	;; What ever happened to i-f-c-literally
  	(let (file-name-handler-alist)
! 	  (insert-file-contents-internal (package-get-staging-dir filename)))
  	(if (not (string= (md5 (current-buffer))
  			  (package-get-info-prop this-package
  						 'md5sum)))
  	    (error "Package %s does not match md5 checksum" filename)))
        (message "Retrieved package %s" filename) (sit-for 0)
        (let ((status
! 	     (package-admin-add-binary-package
! 	      (package-get-staging-dir filename))))
  	(when (not (= status 0))
  	  (message "Package failed.")
  	  (switch-to-buffer package-admin-temp-buffer)))
--- 286,328 ----
        ;; and copy it into the staging directory.  Then validate
        ;; the checksum.  Finally, install the package.
        (while (and search-dirs
! 		  (or (not full-package-filename)
! 		      (not (file-exists-p full-package-filename))))
! 	(if (null (car (car search-dirs)))
! 	    (progn
! 	      (setq full-package-filename
! 		    (expand-file-name
! 		     (substitute-in-file-name
! 		      (concat (file-name-as-directory
! 			       (car (cdr (car search-dirs))))
! 			      filename))))
! 	      )
! 	  (if (file-exists-p (package-get-remote-filename
! 			      (car search-dirs) filename))
! 	      (progn
! 		(setq full-package-filename (package-get-staging-dir filename))
! 		(copy-file (package-get-remote-filename (car search-dirs)
! 							filename)
! 			   full-package-filename)
! 		)))
! 	(setq search-dirs (cdr search-dirs))
! 	)
!       (if (or (not full-package-filename)
! 	      (not (file-exists-p full-package-filename)))
  	  (error "Unable to find file %s" filename))
        ;; Validate the md5 checksum
        ;; Doing it with XEmacs removes the need for an external md5 program
        (with-temp-buffer
  	;; What ever happened to i-f-c-literally
  	(let (file-name-handler-alist)
! 	  (insert-file-contents-internal full-package-filename))
  	(if (not (string= (md5 (current-buffer))
  			  (package-get-info-prop this-package
  						 'md5sum)))
  	    (error "Package %s does not match md5 checksum" filename)))
        (message "Retrieved package %s" filename) (sit-for 0)
        (let ((status
! 	     (package-admin-add-binary-package full-package-filename)))
  	(when (not (= status 0))
  	  (message "Package failed.")
  	  (switch-to-buffer package-admin-temp-buffer)))
***************
*** 279,285 ****
        (message "Added package") (sit-for 0)
        (setq found t))
      (if (and found package-get-remove-copy)
! 	(delete-file (package-get-staging-dir filename)))
      ))
  
  (defun package-get-info-find-package (which name)
--- 330,336 ----
        (message "Added package") (sit-for 0)
        (setq found t))
      (if (and found package-get-remove-copy)
! 	(delete-file full-package-filename))
      ))
  
  (defun package-get-info-find-package (which name)
***************
*** 304,310 ****
    `package-get-info-find-package'.  If VERSION is nil, then return the 
    first (aka most recent) version.  Use `package-get-info-find-prop'
    to retrieve a particular property from the value returned by this."
!   (interactive "xPackage Info: \nsVersion: ")
    (while (and version package (not (string= (plist-get (car package) 'version) version)))
      (setq package (cdr package)))
    (if package (car package)))
--- 355,361 ----
    `package-get-info-find-package'.  If VERSION is nil, then return the 
    first (aka most recent) version.  Use `package-get-info-find-prop'
    to retrieve a particular property from the value returned by this."
!   (interactive (package-get-interactive-package-query t t))
    (while (and version package (not (string= (plist-get (car package) 'version) version)))
      (setq package (cdr package)))
    (if package (car package)))
